\usepackage{url}
%\usepackage{mathrsfs} % for strange math letters
%\usepackage{lscape}
%\usepackage{tikz} %per pallini colorati in esempio colori
\usepackage{xcolor}
\definecolor{WhiteSmoke}{rgb}{0.960784,0.960784,0.960784}
\definecolor{RGBex0}{RGB}{255,239,213}
\definecolor{RGBex1}{RGB}{255,240,245}
\definecolor{RGBex2}{RGB}{255,222,173}
\definecolor{RGBex3}{RGB}{119,136,153}
\definecolor{RGBex4}{RGB}{188,143,143}
\definecolor{RGBex5}{RGB}{255,245,238}
%\usepackage{fancyhdr}
%\usepackage{fancyvrb}
%\usepackage{amsmath}
%\usepackage{amsfonts}
%\usepackage{enumerate}
%\usepackage[pdftex]{graphicx}
%\usepackage{subcaption}
\usepackage{color}
\usepackage{hyperref}
%\usepackage{marvosym}
%\usepackage{stmaryrd}
%\usepackage{listings}
%\usepackage[cal=boondoxo]{mathalfa}
%:
%\usepackage{pzccal}
\usepackage{listings}
%\usepackage[cal=boondoxo]{mathalfa}
\lstset{language=Java,
	basicstyle=\ttfamily,
	captionpos=b,
	numbers=left,
	tabsize=2,
	numbersep=5pt,
	commentstyle=\color{green},
	keywordstyle=\color{blue},
	alsoletter={},
	deletekeywords={},
	morekeywords={}}
\newfont{\tap}{tap scaled 1200}
%%%% ---------------------------------------------
%%%% START setting per package listing
%%%% ---------------------------------------------
\lstloadlanguages{Prolog,Java}
\lstdefinelanguage{tuProlog}[]{Prolog}{
	alsoletter={<-},
	emph={
		returns,<-,java_object,java_class,java_array_set,
		class,new_object,load_convention
	},
	emphstyle=\color{RoyalBlue}
}
\lstset{language=Prolog,
	basicstyle=\fontsize{9}{10}\selectfont\ttfamily,
	backgroundcolor=\color{WhiteSmoke},
	numbers=none,
	frame=single,
	tabsize=2,
	sensitive=true,
	showspaces=false, showtabs=false, showstringspaces=false,
	commentstyle=\color{blue},
	stringstyle=\color{black},
}

% Author Data
\newcommand{\SMlong}{Stefano Mariani}
\newcommand{\AOlong}{Andrea Omicini}
\newcommand{\SMshort}{S. Mariani}
\newcommand{\AOshort}{A. Omicini}
\newcommand{\SMidx}{Mariani, Stefano}
\newcommand{\AOidx}{Omicini, Andrea}
\newcommand{\SMmail}{s.mariani@unibo.it}
\newcommand{\AOmail}{andrea.omicini@unibo.it}
\newcommand{\xinstCE}{DISI, \textsc{Alma Mater Studiorum}--Universit\`{a} di Bologna}
\newcommand{\xaddrCE}{via Sacchi 3}
\newcommand{\xcityCE}{47521 Cesena, Italy}

\newcommand{\rcrev}[1]{\color{blue}#1\normalcolor}

% Names
\newcommand{\rest}{{REST}}
\newcommand{\restful}{\rest{}ful}
\newcommand{\LVLP}{{LVLP}}
\newcommand{\lvlp}{{LVLP}}
\newcommand{\tuprolog}{{{\sf{tu}}{P}rolog}}
\newcommand{\iot}{{IoT}}
\newcommand{\iotlong}{{I}nternet of {T}hings}
\newcommand{\ioit}{{IoIT}}
\newcommand{\ioitlong}{{I}nternet of {I}ntelligent {T}hings}
\newcommand{\lpaas}{{LPaaS}}
\newcommand{\saas}{{SaaS}}
\newcommand{\soa}{{SOA}}
\newcommand{\apice}{{\sf APICe}}
\newcommand{\prolog}{{P}rolog}
\newcommand{\concurrentprolog}{{Concurrent \prolog}}
\newcommand{\deltaprolog}{{Delta \prolog}}
\newcommand{\sharedprolog}{{Shared \prolog}}
\newcommand{\scala}{{Scala}}
\newcommand{\jedi}{{JEDI}}
\newcommand{\exat}{{eXAT}}
\newcommand{\erlang}{{E}rlang}
\newcommand{\agentspeak}{{A}gent{S}peak}
\newcommand{\moklong}{$\mathpzc{M}$olecules $\mathpzc{o}$f $\mathpzc{K}$nowledge}
\newcommand{\mok}{$\mathpzc{MoK}$}
\newcommand{\mokf}{\mathcal{F}_{\mathcal{M}o\mathcal{K}}}
\newcommand{\moknews}{\mok{}-News}
\newcommand{\biopepa}{{BioPEPA}}
\newcommand{\pepa}{{PEPA}}
\newcommand{\fma}{{\sf fMA}}
\newcommand{\linda}{{\sc Linda}}
\newcommand{\geolinda}{{\sc GeoLinda}}
\newcommand{\stlinda}{{\sc $\sigma\tau$-Linda}}
\newcommand{\slinda}{{S}warm{L}inda}
\newcommand{\ulinda}{{\sc uLinda}}
\newcommand{\problinca}{{\tt ProbLinCa}}
\newcommand{\Linda}{{\large\sc Linda}}
\newcommand{\Ulinda}{{\large\sc uLinda}}
\newcommand{\plinda}{{\sc pLinda}}
\newcommand{\uplinda}{{\sc upLinda}}
\newcommand{\swarmlinda}{{S}warm{L}inda}
\newcommand{\logop}{{\it\sffamily LogOp}}
\newcommand{\lime}{{\sc{L}ime}}
\newcommand{\stoklaim}{{\sc{S}to{K}laim}}
\newcommand{\klaim}{{\sc{K}laim}}
\newcommand{\pklaim}{p{\sc{K}laim}}
\newcommand{\Klaim}{{\large\sc{K}laim}}
\newcommand{\Pklaim}{{\large p\sc{K}laim}}
\newcommand{\linca}{{\tt LinCa}}
\newcommand{\plinca}{{\tt ProbLinCa}}
\newcommand{\Linca}{{\large\tt LinCa}}
\newcommand{\Plinca}{{\large\tt ProbLinCa}}
\newcommand{\pacal}{{$\pi_{pa}$-$calculus$}}
\newcommand{\Pacal}{{\large $\pi_{pa}$-$calculus$}}
\newcommand{\acal}{{$\pi_{a}$-$calculus$}}
\newcommand{\Acal}{{\large $\pi_{a}$-$calculus$}}
\newcommand{\pccs}{{PCCS}}
\newcommand{\respect}{{\sf{R}e{S}pec{T}}}
\newcommand{\tucson}{{\sf{T}u{CS}o{N}}}
\newcommand{\scopes}{{Scopes}}
\newcommand{\luce}{{\sf{{L}u{C}e}}}
\newcommand{\cartago}{{\sf{{CA}rt{A}g{O}}}}
\newcommand{\aea}{{A\&A}}
\newcommand{\simpa}{{simp{A}}}
\newcommand{\gammamodel}{{G}amma}
\newcommand{\cham}{{CHAM}}
\newcommand{\tota}{{TOTA}}
\newcommand{\mars}{{MARS}}
\newcommand{\lgi}{{LGI}}
\newcommand{\sapere}{{SAPERE}}
\newcommand{\alchemist}[0]{{\tap{\textsc{Alchemist}}}}
\newcommand{\prism}{{PRISM}}
\newcommand{\jade}{{\sc Jade}}
\newcommand{\jason}{{Jason}}
\newcommand{\jadelong}{{\sc J}ava {\sc A}gent {\sc DE}velopment Framework}
\newcommand{\hrespect}{{\Large \sf {R}e{S}pec{T}}}
\newcommand{\lrespect}{{\large \sf {R}e{S}pec{T}}}
\newcommand{\haea}{{\Large\sc A\&A}}
\newcommand{\aealong}{Agent \& Artefact}
\newcommand{\fipa}{FIPA}
\newcommand{\acl}{ACL}
\newcommand{\acllong}{$\mathcal{A}$gent $\mathcal{C}$ommunication $\mathcal{L}$anguage}
% Names for subsection titles 
\newcommand{\Tucson}{{\large\sf{T}u{CS}o{N}}}
% Cross-referencing
\newcommand{\labelsec}[1]{\label{sec:#1}}
\newcommand{\xs}[1]{\sectionname~\ref{sec:#1}}
\newcommand{\xsp}[1]{\sectionname~\ref{sec:#1} \onpagename~\pageref{sec:#1}}
\newcommand{\labelssec}[1]{\label{ssec:#1}}
\newcommand{\xss}[1]{\subsectionname~\ref{ssec:#1}}
\newcommand{\xssp}[1]{\subsectionname~\ref{ssec:#1} \onpagename~\pageref{ssec:#1}}
\newcommand{\labelsssec}[1]{\label{sssec:#1}}
\newcommand{\xsss}[1]{\subsectionname~\ref{sssec:#1}}
\newcommand{\xsssp}[1]{\subsectionname~\ref{sssec:#1} \onpagename~\pageref{sssec:#1}}
\newcommand{\labelfig}[1]{\label{fig:#1}}
\newcommand{\xf}[1]{\figurename~\ref{fig:#1}}
\newcommand{\xfs}[2]{\figurename~\ref{fig:#1}-\ref{fig:#2}}
\newcommand{\xfp}[1]{\figurename~\ref{fig:#1} \onpagename~\pageref{fig:#1}}
\newcommand{\labeltab}[1]{\label{tab:#1}}
\newcommand{\xt}[1]{\tablename~\ref{tab:#1}}
\newcommand{\xtp}[1]{\tablename~\ref{tab:#1} \onpagename~\pageref{tab:#1}}
\newcommand{\labeldef}[1]{\label{def:#1}}
\newcommand{\xd}[1]{\definitionname~\ref{def:#1}}
\newcommand{\xdp}[1]{\definitionname ~\ref{def:#1} \onpagename~\pageref{tab:#1}}
\newcommand{\labelex}[1]{\label{ex:#1}}
\newcommand{\xex}[1]{Example~\ref{ex:#1}}
\newcommand{\xexp}[1]{Example~\ref{ex:#1} \onpagename~\pageref{ex:#1}}
\newcommand{\labelprop}[1]{\label{prop:#1}}
\newcommand{\xprop}[1]{Proposition~\ref{prop:#1}}
\newcommand{\xpropp}[1]{Proposition~\ref{prop:#1} \onpagename~\pageref{prop:#1}}
\newcommand{\labelcor}[1]{\label{corol:#1}}
\newcommand{\xcor}[1]{Corollary~\ref{corol:#1}}
\newcommand{\xcorp}[1]{Corollary~\ref{corol:#1} \onpagename~\pageref{corol:#1}}
% Category Names
\newcommand{\sectionname}{Section}
\newcommand{\subsectionname}{Subsection}
\newcommand{\sectionsname}{Sections}
\newcommand{\subsectionsname}{Subsections}
%\newcommand{\secname}{\sectionname}
%\newcommand{\ssecname}{\subsectionname}
%\newcommand{\secsname}{\sectionsname}
%\newcommand{\ssecsname}{\subsectionsname}
%\newcommand{\figurename}{Figure}
%\newcommand{\tablename}{Table}
\newcommand{\onpagename}{on page}
%\newcommand{\figuresname}{Fig.s}
% Linda primitives
\newcommand{\lin}{\texttt{in}}
\newcommand{\linp}{\texttt{inp}}
\newcommand{\lout}{\texttt{out}}
\newcommand{\lrd}{\texttt{rd}}
\newcommand{\lrdp}{\texttt{rdp}}
\newcommand{\lno}{\texttt{no}}
% Bulk primitives
\newcommand{\linall}{\texttt{in\_all}}
\newcommand{\linpall}{\texttt{inp\_all}}
\newcommand{\loutall}{\texttt{out\_all}}
\newcommand{\lrdall}{\texttt{rd\_all}}
\newcommand{\lrdpall}{\texttt{rdp\_all}}
\newcommand{\lnoall}{\texttt{no\_all}}
% Uniform primitives
\newcommand{\uin}{\texttt{uin}}
\newcommand{\urd}{\texttt{urd}}
\newcommand{\uno}{\texttt{uno}}
\newcommand{\uinp}{\texttt{uinp}}
\newcommand{\urdp}{\texttt{urdp}}
\newcommand{\unop}{\texttt{unop}}
\newcommand{\uout}{\texttt{uout}}
% Uniform bulk primitives
\newcommand{\uinall}{\texttt{uin\_all}}
\newcommand{\urdall}{\texttt{urd\_all}}
\newcommand{\unoall}{\texttt{uno\_all}}
% Uniform primitives for subsection titles
\newcommand{\Uin}{\texttt{\large{uin}}}
\newcommand{\Urd}{\texttt{\large{urd}}}
\newcommand{\Uno}{\texttt{\large{uno}}}
\newcommand{\Uout}{\texttt{\large{uout}}}
% Logical Operators
\newcommand{\opand}{{\sc and}}
\newcommand{\opor}{{\sc or}}
\newcommand{\opxor}{{\sc xor}}
\newcommand{\opnot}{{\sc not}}
\newcommand{\opnor}{{\sc nor}}
\newcommand{\opnand}{{\sc nand}}
%
\newcommand{\sopand}{\mbox{{\sc and}}}
\newcommand{\sopor}{\mbox{{\sc or}}}
\newcommand{\sopxor}{\mbox{{\sc xor}}}
\newcommand{\sopnot}{\mbox{{\sc not}}}
\newcommand{\sopnor}{\mbox{{\sc nor}}}
\newcommand{\sopnand}{\mbox{{\sc nand}}}
% Code
\newcommand{\cterm}[1]{{\small \texttt{#1}}}
\newcommand{\cvar}[1]{{\small \cterm{\textit{#1}}}}
\newcommand{\liness}{\\[-1mm]}
\newcommand{\cterms}[1]{\texttt{\footnotesize{#1}\normalsize}}
\newcommand{\ctermss}[1]{\texttt{\scriptsize{#1}\normalsize}}
\newcommand{\cvars}[1]{\cterms{\textit{#1}}}
\newcommand{\cvarss}[1]{\ctermss{\textit{#1}}}
\newcommand{\aeaevent}[1]{\left\langle{#1\/}\right\rangle}
\newcommand{\NTSym}[1]{\left\langle\textit{#1\/}\right\rangle}
\newcommand{\TSym}[1]{\texttt{#1}}
\newcommand{\TSy}[1]{\protect{\verb|{#1}|}}
\newcommand{\guard}[2]{\mathit{Guard}(#1,#2)}
\newcommand{\guardp}[2]{\guard{#1}{\mathtt{#2}}}
\newcommand{\unify}[2]{\mathit{Unify}(#1,#2)}
\newcommand{\unifyp}[2]{\unify{#1}{\mathtt{#2}}}
\newcommand{\trms}[2]{\mathsf{Z}_{#1}({#2})}
\newcommand{\timed}[2]{\mathsf{timed}({#1},{#2})}
\newcommand{\res}[6]{\left\langle#1,#2,#3,#4,#5\right\rangle_{#6}}
\newcommand{\reslast}[6]{\left\langle#1,#2,#3,#4,#5\right\rangle_{#6}^*}
\newcommand{\evaltrans}{\longrightarrow_e}
\newcommand{\reacttrans}{\longrightarrow_r}
\newcommand{\timetrans}{\longrightarrow_t}
%\newcommand{\envtrans}{\longrightarrow_{env}}
\newcommand{\sittrans}{\longrightarrow_{s}}
%\newcommand{\servtrans}{\longrightarrow_s}
\newcommand{\optrans}{\longrightarrow_o}
\newcommand{\logtrans}{\longrightarrow_l}
\newcommand{\fevalname}{\mathsf{E}}
\newcommand{\feval}[3]{\fevalname({#1},{#2},{#3})}
\newcommand{\tcstate}[7]{\left.^{#4,#5\!\!}\left\langle#1,#2,#3\right\rangle^{#6}_{#7}\right.}
\newcommand{\satisf}[2]{\mathsf{sat}({#1},{#2})}
% Formal
\newcommand{\bnfs} {|}
\newcommand{\comp} {;\!\!}
\newcommand{\mopor} {\textsc{OR}}
\newcommand{\mopand} {\textsc{AND}}
\newcommand{\mopxor} {\textsc{XOR}}
\newcommand{\neweq}[1]  {\equiv_{#1}}
\newcommand{\handles} {m}
\newcommand{\Cont}[2]   {(#1)#2}
\newcommand{\cont}[2]   {(#1)#2}
\newcommand{\cset}[1]    {\overline{#1}}
\newcommand{\void}      {\epsilon}
\newcommand{\ALL}      {\mathit{ALL}}
\newcommand{\tuple}[1] {\langle #1 \rangle}
%% labelled vars
\newcommand{\ar}[1]{\mathit{ar}({#1})}
\newcommand{\labelass}[2]{\langle{#1},{#2}\rangle}
\newcommand{\true}{\mathsf{true}}
\newcommand{\false}{\mathsf{false}}
\newcommand{\lab}{\Lambda}
\newcommand{\lb}{\widetilde\ell}
%% table internal commands
\newcommand{\tz}{&\scriptsize}
\newcommand{\lz}{\\[-2mm]}

%Numbered environment: Example
\newcounter{example}[section]
\newenvironment{example}[1][]{\refstepcounter{example}\par\medskip
   \noindent \textbf{Example~\theexample. #1} \rmfamily}{\medskip}


\newtheorem{definition}{Definition}[section]
\newtheorem{theorem}[definition]{Theorem}%[section]
\newtheorem{fact}[definition]{Fact}%[section]
\newtheorem{lemma}[definition]{Lemma}
\newtheorem{assumption}[definition]{Assumption}
\newtheorem{proposition}[definition]{Proposition}
\newtheorem{remark}[definition]{Remark}
\newtheorem{corollary}[definition]{Corollary}
\newtheorem{claim}[definition]{Claim}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%\newenvironment{proof}
%  {\trivlist\PRstyle\item[]{\bfseries Proof:}\newline}{\QED\endtrivlist}
%\def\squareforqed{\hbox{\rlap{$\sqcap$}$\sqcup$}}
%\def\QED{\ifmmode\squareforqed\else{\unskip\nobreak\hfil
%\penalty50\hskip1em\null\nobreak\hfil\squareforqed
%\parfillskip=0pt\finalhyphendemerits=0\endgraf}\fi}
\newenvironment{proof}{\paragraph{Proof:}}{\hfill$\square$}

\newcommand\bti[1]{\texttt{\textbf{#1}}}
\newcommand\bt[1]{\texttt{#1}}
\newcommand\template[1]{\textit{Template: }\texttt{#1}}
\newcommand\exception[1]{\textit{Exception: }\texttt{#1}}
\newcommand\ttit[1]{\texttt{\textit{#1}}}

\newenvironment{changemargin}[2]{%
\begin{list}{}{%
\setlength{\topsep}{0pt}%
\setlength{\leftmargin}{#1}%
\setlength{\rightmargin}{#2}%
\setlength{\listparindent}{\parindent}%
\setlength{\itemindent}{\parindent}%
\setlength{\parsep}{\parskip}%
}%
\item[]}{\end{list}}


%******************************************************************************%
% Macro tabella GC
%******************************************************************************%
\newcommand{\myEntry}[5]{\multicolumn{2}{l|}{#1}&\multirow{2}{*}{\texttt{#4}}\\#2&#3&\\}
\newcommand{\httpMethod}[2]{\texttt{#1 #2}}
\newcommand{\httpGet}[1]{\httpMethod{{\color{cyan}GET}}{#1}}
\newcommand{\httpPost}[1]{\httpMethod{{\color{green}POST}}{#1}}
\newcommand{\httpPut}[1]{\httpMethod{{\color{orange}PUT}}{#1}}
\newcommand{\httpDelete}[1]{\httpMethod{{\color{red}DELETE}}{#1}}
\newcommand{\httpReq}[1]{\httpMethod{{\color{gray}Req: }}{#1}}
\newcommand{\httpRes}[1]{\httpMethod{{\color{gray}Res: }}{#1}}
\newcommand{\httpQueryA}[2]{\texttt{{\color{gray}?}#1=#2}}
\newcommand{\httpQueryAA}[4]{\texttt{{\color{gray}?}#1=#2{\color{gray}\&}#3=#4}}
\newcommand{\httpQueryAAA}[6]{\texttt{{\color{gray}?}#1=#2{\color{gray}\&}#3=#4{\color{gray}\&}#5=#6}}
\newcommand{\httpQueryAAAA}[8]{\texttt{{\color{gray}?}#1=#2{\color{gray}\&}#3=#4}\\\hfill{}\texttt{{\color{gray}\&}#5=#6{\color{gray}\&}#7=#8}}
\newcommand{\var}[1]{\textit{#1}}
\newcommand{\Var}[1]{{\textit{#1}}}
\newcommand{\myHttpPlEntry}[5]{\myEntry{#1}{\httpReq{#2}}{\httpRes{#3}}{#4}{\texttt{#5}}}

